;HRJ May 11 2014 convert \lb\ to LOW; \hb\ to HIGH
;HRJ assembler accepts nnn#nnn as split octal
;HRJ needs END statement; changed 0xnn to 0nnH

			ORG	000#000
			JMP	INCHAR
			ORG	000#010
RESET:		JMP	RESET
			ORG	000#020
			JMP	OUTCHAR
			ORG	000#070
			JMP	INCHAR
			ORG 000#100
			JMP	SHOOTSTR
INPORT:	EQU 2
OUTPORT: EQU 12
CR:		EQU 015

;;; HERE IS THE USER DEFINED CHARACTER INPUT TO READ FROM SERIAL PORT
	
INCHAR:	INP INPORT
	NDA
	JFS INCHAR
	NDI 7FH
	RET

;;; HERE IS THE USER DEFINED PRINT ROUTINE FOR A SERIAL PORT
	
OUTCHAR:

	OUT OUTPORT
	RET



			ORG	014#000
SHOOTSTR:	LAI	CR			;DISPLAY A LINEFEED TO
			RST	2			;	INITIALZE DISPLAY;
;			DATA 0x15

			LLI	LOW HMESS	;SET ADDRESS POINTERS
			LHI	HIGH HMESS	;	TO HEADING MESSAGE;
			CAL	OUTPUT		;PRINT MESSAGE & RETURN;
			CAL	INPUT		;CALL INPUT LOOPER;
			CPI	116		;IS FIRST LETTER 'N'?
			JTZ	ASTART		;IF SO THEN PLUNGE INTO GAME;
			LLI	LOW PAGE1	;IF NOT THEN POINT TO FIRST
			LHI	HIGH PAGE1	;	PAGE OF RULES TEXT;
			CAL	OUTPUT		;AND GO OUTPUT RULES MESSAGE;
			RST	7			;WAIT FOR GOAHEAD;
;			DATA 0x3D

			LLI	LOW PAGE2	;POINT TO SECOND PAGE OF
			LHI	HIGH PAGE2	;	RULES TEXT;
			CAL	OUTPUT		;DISPLAY SECOND PAGE OF RULES;
			RST 7			;WAIT FOR GOAHEAD;
;			DATA 0x3D

			LLI	LOW PAGE3	;POINT TO THIRD PAGE OF RULES;
			LHI	HIGH PAGE3	;	RULES TEXT;
			CAL OUTPUT		;DISPLAY THIRD PAGE OF RULES;
			RST 7			;WAIT FOR GOAHEAD
;			DATA 0x3D

ASTART:		LAI	CR			;SET UP LINEFEED
			RST	2			;DISPLAY ONE LINEFEED,
			RST	2			;	THEN A SECOND LINEFEED
			RST	2			;	THEN A THIRD
;			DATA 0x15
;			DATA 0x15
;			DATA 0x15


			LBI	0			;INITIALIZE THE UNIVERSE
			LCI	1			;	TO STARTING PATTERN;
			LDB				;THEN CLEAR SHOT COUNTER;
CNTSHOT:	IND				;COUNT A SHOT (ANTICIPATORY),
SETCNT:		LEI	012			;LOOP COUNT 10 INTERATIONS
DISLOOP:	DCE				;IS THE LOOP DONE?
			JTZ	WINTEST		;IF SO THEN GO TO WIN TESTING.
			LAE				;IF NOT THEN CONTINUE DISPLAY.
			CPI	6			;IF IS FOURTH CYCLE?
			JTZ	LINFEED		;IF SO THEN NEW LINE NEEDED.
			CPI	3			;IS IT SEVENTH CYCLE?
			JTZ	LINFEED		;IF SO THEN NEW LINE NEEDED
			CPI	5			;IS IT STAR NUMBER 5
			JTZ	FIVTST		;IF SO THEN GO TEST STAR 5
NEDOT:		XRA				;CLEAR THE CARRY (AND A TOO)
			LAB				;MOVE UNIVERSE TO A
			RRC				;ROTATE NEXT PLACE INTO CARRY,
			LBA				;SAVE IT IN 8 FOR A WHILE
PSEUDOT:	JFC	LOADOT		;IF DOT THEN GO OUTPUT DOT;
			LAI	052			;OTHERWISE LOAD A STAR;
			RST	2			;THEN PRINT THE STAR
;			DATA 0x15

			JMP	SPCNOW		;BRANCH AROUND THE DOT LOGIC;
LOADOT:		LAI	056			;LOAD A DOT
			RST	2			;THEN PRINT THE DOT
;			DATA 0x15

SPCNOW:		LAI	040			;LOAD A SPACE;
			RST	2			;PRINT ONE SPACE;
			RST	2			;	THEN PRINT A SECOND
;			DATA 0x15
;			DATA 0x15

			JMP	DISLOOP		;WALTZ AROUND LOOP ONCE MORE;
LINFEED:	LAI	CR			;LOAD A LINE FEED.
			RST	2			;DISPLAY A LINE FEED
			RST	2			;	THEN A SECOND ONE;
;			DATA 0x15
;			DATA 0x15

			JMP	NEDOT		;BACK TO PRINT NEXT DOT OR STAR.
FIVTST:		XRA				;NO OPERATION INTENDED - LEFTOVER.
			LAC				;GET POSITION 5 STATUS;
			RRC				;PUT STATUS INTO CARRY;
			JMP	PSEUDOT	;REJOIN MIANLINE AFTER RCC;
GOTSTAR:	LAI	CR			;LOAD A LINEFEED;
			RST	2			;HAVE FINISHED UNIVERSE PRINT,
			RST	2			;	SO PRINT SEVERAL
			RST	2			;	LINE FEEDS
			RST	2			;	TO SEPARATE
			RST	2			;	SUCESSIVE ROUNDS
;			DATA 0X15
;			DATA 0X15
;			DATA 0X15
;			DATA 0X15
;			DATA 0X15

			LLI	LOW MESS7	;POINT TO THE 'YOUR SHOT'
			LHI	HIGH MESS7	;	MESSAGE;
			CAL	OUTPUT		;THEN GO PRINT IT
			RST	0			;CALL INPUT FOR CHARACTER
			RST	2			;IMMEDIATELY CHEO THE INPUT;
;			DATA 0x05
;			DATA 0x15


			LEA				;SAVE INPUT TEMPORARILY IN E;
			LAI	CR			;LOAD A LINE FEED
			RST	2			;PRINT THREE LINE FEEDS TO
			RST	2			;	SPACE OUT THE RESPONSE
			RST	2			;	A BIT MORE
;			DATA 0x15
;			DATA 0x15
;			DATA 0x15

			LAE				;RECOVER INPUT FOR TESTING
			LEI	9D			;LOOP COUNT FOR TABLE SEARCH;
			LLI	LOW MASKTAB	;SET UP POINTER TO THE 
			LHI	HIGH MASKTAB	;	THE MASK TABLE;
NEXTGRUP:	CPM				;IS INPUT EQUAL TABLE CHARACTER?
			JTZ	FOUND		;IF SO THEN GO ALTER STRUCTER OF
			DCE				;	THE UNIVERSE OTHERWISE JUST
			JTZ	INVAL		;	CHECK END OF LOOP;
			INL				;INCREMENT THE L
			INL				;	REGISTER POINTER
			INL				;	FOUR TIMES TO GET
			INL				;	TO NEXT TABLE ENTRY;
			JMP	NEXTGRUP	;THEN GO TEST NEXT ENTRY;
FOUND:		INL				;POINT TO POSITION MASK
			LAM				;	AND LOAD MASK INTO A;
			CPI	0			;IS IT ZERO?
			JFZ	UNIV2A		;IF NOT THEN FRINGE POSITION;
			LAC				;OTHERWISE THE CENTER POSITION;
			CPI	1			;IS A STAR IN CENTER?
			JFZ	BADFELO		;IF NOT THEN HAVE WRONG MOVE;
			JMP	NEXBYT		;IFSO THEN GO PROCESS STAR
UNIV2A:		LAB				;REST OF UNIVERS TO A;
			NDM				;AND WITH MASK TO ISOLATE STAR;
			JTZ	BADFELO		;IF NOT STAR THEN WRONG MOVE;
NEXBYT:		INL				;POINT TO THE GALAXY MASK;
			LAB				;FETCH UNIVERSE AGAIN
			XRM				;AND COMPLEME NT THE UNIVERSE
			LBA				;	ON A FINE PERFORMANCE
			INL				;POINT TO CERNTER MASK
			LAC				;FETCH CENTER OF UNIVERSE
			XRM				;COMPLEMENT CENTER IF REQUIRED
			LCA				;SAVE CENTER OF UNIVERSE
			JMP	CNTSHOT		;GO DISPLAY A NEW UNIVERSE
INVAL:		CPI	177			;WAS INVALID SHOT A D'DELETE'?
			JFZ	NOTVAL		;IF NOT THEN RECYCLE BAD STAR;
			LLI	LOW MESS6	;OTHER POINT TO GIVING UP
			LLI	HIGH MESS6	;	MESSAGE;
			JMP	PRNTIT		;DISPLAY THEN TEST FOR RESTART
NOTVAL:		LLI	LOW MESS2	;POINT TO INVALID STAR
			LHI	HIGH MESS2	;	NUMBER MESSAGE
OUTMES:		CAL	OUTPUT		;OUTPUT A MESSAGE THEN
			JMP	SETCNT		;	GO DISPLAY THE UNIVERSE AGAIN;
WINTEST:	LAB				;MOVE UNIVERSE TO A
			CPI 11111111B	;ARE ALL FRINGE STARS PRESENT?
			JFZ	LOSSTST		;IF NOT SEE IF PLAYER HAS LOST;
			LAC				;FETCH CENTER OF UNIVERSE;
			CPI	0			;IS CENTER OF UNIVERSE EMPTY
			JFZ	GOTSTAR		;IS FULL THEN NOT WIN;
			LLI	LOW MESS4	;NO STAR! GOT A WIN FOLKS
			LHI	HIGH MESS4	;	SO POINT TO WIN MESSAGE;
			CAL OUTPUT		;THEN DISPLAY WIN MESSAGE;
			LEI	060			;BEGIN BINARY TO DECIMAL CONVERSION
			LBE				;	BY SETTING ALL THREE WORKING
			LCE				;	REGISTER TO (ASCII) ZERO;
			DCD				;GET RID OF LAST SHOT;
			LAD				;MOVE SHOT COUNT TO A FOR TEST;
			CPI	0			;TEST FOR ZERO (NOT NEEDED IN
			JTZ	LSTSIG		;	SHOOTING STARS BUT GENERALLY
							;	USEFUL WITH CONVERSIONS);
			LAI	073			;NEED COMPARE TO ASCII '9'+1;
MOREDEC:	INE				;COUNT UP ONE IN 1.S DIGIT;
			CPE				;IS IT EQUAL TO OVERFLOW CODE?
			JFZ	TALLYHO		;IF NOT THEN TALLY AND CONTINUE
			LEI	060			;ELSE RESET 1'S DIGIT TO ZERO
			INC				;	AND CARRY INTO NEXT DIGIT;
			CPC				;IS IT EQUAL TO OVERFLOW CODE TOO?
			JFZ	TALLYHO		;IF NOT THEN TALLY AND CONTINUE;
			LCI	060			;ELSE RESET MIDDLE DIGIT TO ZERO
			INB				;	AND CARRY INTO M.S. DIGIT;
TALLYHO:	DCD				;DECREMENT SCORE COUNTER FOR TALLY
			JFZ	MOREDEC		;IF NOT ZERO THEN KEEP OPTIONS
			LAB				;FETCH LEADING DIGIT TO A:
			CPI	060			;IS IT (ASCII) ZERO?
			JFZ	THREED		;IF NOT GO DISPLAY THREE DIGITS
			LAC				;FETCH MIDDLE DIGIT TO A;
			CPI	060			;IS IT (ASCII) ZERO TOO?
			JFZ MIDPRINT	;IF NOT GO DISPLAY TWO DIGITS
			JMP	LSTSIG		;IF SO DISPLAY ONLY ONE;
THREED:
			RST	2			;DISPLAY THREE DIGITS, LEFT FIRST;
;			DATA 0x15

			LAC				;FETCH MIDDLE DIGIT TO A;
MIDPRINT:
			RST	2			;DISPLAY TOW DIGITS, LEFT FIRST;
;			DATA 0x15

LSTSIG:		LAE				;FETCH 1'S DIGIT;
			RST	2			;DISPLAY REMAINING DIGIT;
;			DATA 0x15

			LLI	LOW MESS5	;POINT TO FIRST PART OF YOU WIN;
RECYC:		LHI	HIGH MESS5	;SECOND PART OF MESS5/MESS6 POINTER;
PRNTIT:		CAL	OUTPUT		;DISPLAY THE MESSAGE;
			CAL	INPUT		;FETCH A CHARACTER FOR CONTINUE
			CPI	331		;	QUERY, IS IT 'YES"?
;			JTZ	ASTART		;IF SO THEN CONTINUE GAME;
			JMP	ASTART		;WE HAVE NO MONITOR - ALWAYS START
			RST	1			;OTHERWISE CALL EXIT
;			DATA 0x0D
			
LOSSTST:	CPI	0			;IS FRINGE UNIVERSE ALL BLACK HOLES?
			JFZ	GOTSTAR		;IFNOT THEN CONTINUE GAME;
			LAC				;IF SO THEN TEST CENTER POSITION;
			CPI	0			;IS CENTER ALSO BLACK HOLE?
			JFZ	GOTSTAR		;IF NOT THEN CONTINUE GAME;
			LLI	LOW MESS3	;ELSE POINT TO LOSS MESSAGE;
			JMP	RECYC		;AND GO PRINT LOSS;
MASKTAB:	DATA 061, 001, 013, 001 ;36 BYTES OF MASK TABLE
			DATA 062, 002, 007, 000
			DATA 063, 004, 026, 001
			DATA 064, 010, 051, 000
			DATA 065, 000, 132, 001
			DATA 066, 020, 224, 000
			DATA 067, 040, 150, 001
			DATA 070, 100, 340, 000
			DATA 071, 200, 320, 001

OUTPUT:		LAM				;FETCH NEXT MESSAGE BYTE.
			CPI	031			;IS IT A DELIMITER?
			RTZ				;RETURN WHEN DELIMITER FOUND.
			RST	2			;OTHERWISE DISPLAY BYTE;
;			DATA 0x15

			INL				;POINT TO NEXT BYTE;
			JFZ	OUTPUT		;IS IT PAGE BOUNDARY?
			INH				;IF SO INCREMENT PAGE;
			JMP	OUTPUT		;AND THEN RECYCLE.
INPUT:
			RST	0			;GET NEXT CHARACTER
;			DATA 0x05

			LEA				;SAVE IT IN E.
			RST	2			;ECHO ON DISPLAY
;			DATA 0x15
			
GETNEXT:
			RST	0			;GET NEXT CHARACTER;
			RST	2			;ECH ON DISPLY;
;			DATA 0x05
;			DATA 0x15

			CPI	CR			;WAS IT A LINE FEED?
			JFZ	GETNEXT		;IF NOT CONTINUE SCAN.
			LAE				;IF SO, RESTORE FIRST INPUT;
			RET				;AND THEN RETURN TO CALLER;
BADFELO:	LLI	LOW MESS1	;POINT TO THE ERROR MESSAGE
			LHI	HIGH MESS1	;	ADMNISHING BAD "STAR';
			JMP	OUTMES		;AND GO DISPLAY ERROR;
			
			ORG	016#000
MESS1:
			DATA	"HEY! YOU CAN ONLY SHOOT STARS," 
			DATA	012
			DATA	"NOT BLACK HOLES."
			DATA	012
			DATA	"TRY AGIAN!"
			DATA	012,031

			ORG	016#077
MESS2:		DATA	"THAT WASNT A VALID STAR NUMBER!"
			DATA	012
			DATA	"TRY AGAIN!"
			DATA	012,031

			ORG	016#156
MESS3:		DATA	"YOU LOST THE GAME:"
			DATA	012
			DATA	"WANT TO SHOOT SOME MORE STARS!  "
			DATA	031

			ORG	016#243
MESS4:		DATA	"YOU WIN! GOOD SHOOTING:"
			DATA	012
			DATA	"YOU FIRED  "
			DATA	031

			ORG	016#310
MESS5:		DATA	" SHOTS."
			DATA	012
			DATA	"BEST POSSIBLE SCORE IS 11 SHOTS"
			DATA	012
			DATA	"WANT TO SHOOT AGAIN DEADEYE?  "
			DATA	031

			ORG	017#022
MESS6:		DATA	"YOU GIVE UP TOO EASILY!"
			DATA	012
			DATA	"WANT TO SHOOT SOME MORE STARS? "
			DATA	031

			ORG	017#114
MESS7:		DATA	"YOUR SHOT? "
			DATA	031

			ORG	017#131
HMESS:		DATA	"S H O   SSS   TTT   AAA   RRR   SSS"
			DATA	012
			DATA	"        S     T     A A   R R   S"
			DATA	012
			DATA	"O * T   SSS   T     AAA   RRR   SSS"
			DATA	012
			DATA	"          S   T     A A   RR      S"
			DATA	012
			DATA	"I N G   SSS   T     A A   R R   SSS"
			DATA	012
			DATA	"**********S H O O T I N G   S T A R S******"
			DATA	012
			DATA	"           A BRAIN TEASER GAME"
			DATA	012
			DATA	"WANT THE RULES? "
			DATA	031

			ORG	020#147
PAGE1:
			
			DATA	"THERE ARE STARS:      *"
			DATA	012
			DATA	"AND BLACK HOLES:	   ."
			DATA	012
			DATA	012
			DATA	"IN THE UNIVERSE         + + +"
			DATA	012
			DATA	"                        + + +"
			DATA	012
			DATA	"                        + + +"
			DATA	012
			DATA	"YOU SHOOT A STAR"
			DATA	012
			DATA	"(NOT A BLACK HOLE)"
			DATA	012
			DATA	"BY TYPING ITS NUMBER    1 2 3"
			DATA	012
			DATA	"                        4 5 6" 
			DATA	012
			DATA	"                        7 8 9"
			DATA	012
			DATA    "THAT CHANGES THE STAR TO A BLACK HOLE!"
			DATA	012
			DATA	"(TO SEE MORE RULES, TYPE ANY KEY.) "
			DATA	031

			ORG 021#277
PAGE2:
			DATA	"EACH STAR IS IN A GALAXY. WHEN YOU"
			DATA	012
			DATA	"SHOOT A STAR, EVERYTHING IN ITS GALAXY"
			DATA	012
			DATA	"CHANGES. ALL STARS BECOME BLOCK HOLES"
			DATA	012
			DATA	"AND ALL BLACK HOLES BECOME STARS."
			DATA	012
			DATA	012
			DATA	"GALAXIES"
			DATA	012
			DATA	"1*.   *2*   .3*   *..  .*."
			DATA	012
			DATA	"**.   ...   .**   4..  *5*"
			DATA	012
			DATA	"...   ...   ...   *..  .*."
			DATA	012
			DATA	012
			DATA	"..*   ...   ...   ..."
			DATA	012
			DATA	"..6   **.   ...   .**"
			DATA	012
			DATA	"..*   7**   *8*   .*9"
			DATA	012
			DATA	"(TYPE ANY KEY FOR LAST PAGE OF RULES.) "
			DATA	031

			ORG	023#137
PAGE3:
			DATA	"THE GAME STARTS"
			DATA	012
			DATA	"WITH THE UNIVERSE  ..."
			DATA	012
			DATA	"LIKE THIS          .*."
			DATA	012
			DATA	"                   ..."
			DATA	012
			DATA	012
			DATA	"YOU WIN WHEN YOU   ***"
			DATA	012
			DATA	"CHANGE IT TO THIS  *.*"
			DATA	012
			DATA	"                   ***"
			DATA	012
			DATA	012
			DATA	"YOU LOSE IF YOU    ..."
			DATA	012
			DATA	"GET THIS           ..."
			DATA	012
			DATA	"                   ..."
			DATA	012
			DATA	012
			DATA	"READY TO PLAY. TYPE ANY KEY TO START"
			DATA	012
			DATA	"THE GAME. GOOD LUCK!"
			DATA	031
			END	;HRJ
			
